
#include <iostream>
#include "cifrasSubstituicao.hpp"



int CifrasSubstituicao::mod(int numero, int base){
	
  int resto;
  
  resto = numero % base;  // resto da diviso inteira, pode ser negativo
  
  if(resto >= 0)
    return resto;
  else
    return (resto + base);
}


int CifrasSubstituicao::entradaParaAlfabeto(int n){
  if(n >= 97 && n <= 122) { //[a-z]
    return n - 97;
  }
  else {
    std::cout << "Erro";
    return -1;
  }
}

// funo que converte do Alfabeto para ASCII

/* --> parmetro de entrada:um inteiro
   <- parmetro de sada:um inteiro
*/ 
int CifrasSubstituicao::alfabetoParaSaida(int n){
  
  if(n >= 0 && n <= 25) { //[a-z]
    return n + 97;
  }
  else {
    return n;
  }
}


/* Encriptar de um carcter, ISO-8859-1 */
int CifrasSubstituicao::encriptarDS(int m,int chave){ 
  int valorNoAlfabeto,encriptar,valorASCII; 

  //obter o valor do carcter no Alfabeto 
  //verificar se o carcter pertence ao Alfabeto 
  if(m >= 97 && m <= 122){
    valorNoAlfabeto = entradaParaAlfabeto(m);
  }
  else {
    // Os carcteres no considerados na cifra no so cifrados
    return m; 
  }
  // Se no houve problemas
  encriptar = cifrarDS(valorNoAlfabeto,chave); 
  //obter o valor do caracter no ISO8859_1 
  valorASCII = alfabetoParaSaida(encriptar);
  return valorASCII;
} 


/* Desencriptar de um carcter, ISO-8859-1 */
int CifrasSubstituicao::desencriptarDS(int c,int chave){ 
  int valorNoAlfabeto,desencriptar,valorASCII,diferenca;

  //obter o valor do carcter no Alfabeto 
  //verificar se o carcter pertence ao Alfabeto 
  if(c >= 97 && c <= 122){
    valorNoAlfabeto = entradaParaAlfabeto(c); 
  }
  else {
    // Os carcteres no considerados na cifra no so decifrados
    return c;
  }
  diferenca = decifrarDS(valorNoAlfabeto,chave);
  desencriptar = mod(diferenca,compAlfa); 
  valorASCII = alfabetoParaSaida(desencriptar); 
  return valorASCII; 
}



// Cifra de Deslocamento Simples
int CifrasSubstituicao::cifrarDS(int m,int c){
  
  return((m + c) % compAlfa);
  
}


//  Cifra de Deslocamento Simples (funo inversa)
int CifrasSubstituicao::decifrarDS(int e,int c){
  
  return(mod((e - c),compAlfa));
  
}


