/*
 * Cifras Clssicas de Deslocamento
 *
 * Cifra de deslocamento simples
 */

#ifndef CIFRASSUBSTITUICAO
#define CIFRASSUBSTITUICAO

class CifrasSubstituicao {
	
private:
  /* Comprimento do Alfabeto */
  int compAlfa = 26; 
  /* Cdigo de erro para nmeros que no so primos entre si */
  //struct erroPrimosRelativos {};
  /*  Cdigo de erro para caracteres fora do Alfabeto */
  //struct naoAlfa {};

  /*
   * Mtodo mdulo
   * --> numero, inteiro 
   * --> base, inteiro 
   * <-- resto, resto (>0) da diviso inteira de numero por base
   *

   * Ajusta o valor do resto para o caso em que o nmero de entrada 
   * negativo
   */
  int mod(int numero, int base);
  
public:

  /* 
   * Mtodo que converte a codificao ASCII (a-z) para Alfabeto-A  (0-25)
   * --> n, codificao do carcter lido
   * <-- m, valor ajustado para a gama 0<= m < compAlfa
   *
   * Erro: caso de um carcter no reconhecido
  */
  int entradaParaAlfabeto(int n);

  /*
   * Mtodo que converte do Alfabeto-A para Codificao ASCII
   * --> m, 0<= m < compAlfa
   * <-- n, codificao do carcter correspondente
   */
  int alfabetoParaSaida(int n);

  /*
   * Encriptar atravs da cifra Deslocamento Simples
   * --> m, carcter a encriptar, codificao ISO-8859-1
   *     chave, 0<= m < compAlfa
   * <-- c, carcter cifrado, codificao ISO-8859-1
   */
  int encriptarDS(int m,int chave);
  
  /*
   * Desencriptar atravs da cifra Deslocamento Simples
   * --> c, carcter a desencriptar, codificao ISO-8859-1
   *     chave, 0<= m < compAlfa
   * <-- m,  carcter desencriptado, codificao ISO-8859-1
   */
  int desencriptarDS(int c,int chave);

  /*
   * Cifra de Deslocamento Simples
   * 
   * --> m, 0<= m < compAlfa, nmero natural a encriptar
   *     chave, 0<= chave < compAlfa, chave para encriptar
   * <-- c, 0<= m < compAlfa, nmero natural encriptado   
   */
  int cifrarDS(int m,int c);


  /*
   * Cifra de Deslocamento Simples (funo inversa)
   *    
   * --> e, 0<= m < compAlfa, nmero natural a desencriptar
   *     c, 0<= c < compAlfa, chave para encriptar
   * <-- d, 0<= c < compAlfa, nmero natural desencriptado
   */
  int decifrarDS(int e,int c);
};

#endif
