// Copyright (c) 2021, Pedro Quaresma <pedro@mat.uc.pt>

#include <iostream>

#include <cstdio>
#include <cstring> // permite a utilização de funcoes que manipulam strings 

#include "cifrasSubstituicao.hpp" // Classe com as Cifras de Deslocamento

using namespace std;

int main(int argc, char *argv[]){

  
  //fl -> o ficheiro de entrada(leitura) 
  //fe -> o ficheiro de saida(escrita) 
  
  FILE *fl,*fe;
  
  //verificar o número de argumento
  if(argc!=4){
    cout << "\nUtilização: encriptarDS nome_ficheiro_entrada chave nome_ficheiro_saida\n\n"; 
    return(1);
  }
  
  //Declaração das variáveis
  char *mensnormal, *menscifrada;
  int ch;
  int caracter;
  int resultado;
  int chave;
  
  
  //cópia do ficheiro de entrada
  mensnormal = argv[1];
  
  
  //funcao atoi recebe uma string e devolve o inteiro que nela esta representado
  chave=atoi(argv[2]);
  
  //cópia do ficheiro de saida
  menscifrada = argv[3];
  
  
  //abrir o ficheiro para a leitura
  fl = fopen(mensnormal,"r");
  
  //verificar se o ficheiro foi aberto ou nao
  //caso contrario o programa termina
  if(fl==NULL){
    cout << "Impossível abrir o ficheiro " << mensnormal << endl;
    return(2);
  }
  
  //Abrir o ficheiro para escrever a mensagem cifrada
  if((fe = fopen(menscifrada,"w"))==NULL){
    cout << "Impossível criar o ficheiro " << menscifrada << endl;
    return(3);
  }

  // Encriptar da mensagem
  CifrasSubstituicao cifraDS; // Objecto, instância da Classe CifrasSubstituicao

  // Aplicar a Cifra de Deslocamento Simples
  while((ch = fgetc(fl)) != EOF){
    resultado = cifraDS.encriptarDS(ch,chave);
    fprintf(fe,"%c",resultado);
  }
  
  
  //Fechar os ficheiros
  fclose(fl);
  fclose(fe);
  
  return(0);
  
}
